
from flask import request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
from core.model.BadgeModel import BadgeModel
from core.model.FCModel import FCModel
from core.model.FoodSessionModel import FoodSessionModel
from core.model.BadgeUserModel import BadgeUserModel
from core.model.KitSessionModel import KitSessionModel
# 
from core.model.WebCameraModel import WebCameraModel
from core.library.email import EMAIL

from .. import Cryptography
from flask import  app
from random import randint
import datetime
from datetime import timedelta,date,datetime,time
from werkzeug.utils import secure_filename
from os.path import join, dirname, realpath
import os

import pandas as pd
import numpy as np
import ast

import csv
from io import StringIO
import io
from flask import Response

import xlwt

from flask import Flask, make_response
import pyexcel as pe
import base64
import cv2

from core.library.BackgroundTasks import BackgroundTasks


app = Blueprint('webcamera', __name__)


@app.route('/<int:conf_id>/<conf_key>/selfie_booth', methods = ["GET", "POST"])
def SelfieBooth(conf_id,conf_key):
	del_nos_array = []
	get_conf      = BadgeModel().GetConf(conf_id,conf_key)
	if get_conf : 
		delegate_no = request.values.get("delegate_no") or  0
		delegate_no = int(delegate_no) if delegate_no else 0
		if delegate_no > 0 : 
			del_nos_array.append(delegate_no)
			del_table_name = get_conf["del_table_name"]
			del_data =  WebCameraModel().GetDelegateDataByNumber(conf_id,delegate_no,del_table_name)
			if del_data : 
				return render_template("selfie_booth/selfie_booth.html",del_data=del_data,del_nos_array=del_nos_array,int=int,type=type)
			else :
				return "<h3 style='color:red;text-align:cetner;'>Delegate data does not exits. </h3>"	
					

			# print(del_nos_array)
		else : 
			flash("Invalid delegate number." , "errorMsg")
			return redirect (url_for('badge_user.BadgeLogin',conf_id=conf_id ,conf_key=conf_key)) 

		# del_nos_array = [1]
		# return render_template("selfie_booth/selfie_booth.html",del_nos_array=del_nos_array,int=int,type=type)
	else :
		return "<h3 style='color:red;text-align:cetner;'>Invalid URL </h3>"	

@app.route('/<int:conf_id>/<conf_key>/delegate_photo', methods = ["GET", "POST"])
def delegate_photo(conf_id,conf_key):
	del_nos_array = []
	get_conf      = BadgeModel().GetConf(conf_id,conf_key)
	if get_conf : 
		delegate_no = request.values.get("delegate_no") or  0
		delegate_no = int(delegate_no) if delegate_no else 0
		if delegate_no > 0 : 
			del_nos_array.append(delegate_no)
			del_table_name = get_conf["del_table_name"]
			del_data =  WebCameraModel().GetDelegateDataByNumber(conf_id,delegate_no,del_table_name)
			if del_data : 
				return render_template("selfie_booth/delegate_photo.html",del_data=del_data,del_nos_array=del_nos_array,int=int,type=type)
			else :
				return "<h3 style='color:red;text-align:cetner;'>Delegate data does not exits. </h3>"	
					

			# print(del_nos_array)
		else : 
			flash("Invalid delegate number." , "errorMsg")
			return redirect (url_for('badge_user.BadgeLogin',conf_id=conf_id ,conf_key=conf_key)) 

		# del_nos_array = [1]
		# return render_template("selfie_booth/selfie_booth.html",del_nos_array=del_nos_array,int=int,type=type)
	else :
		return "<h3 style='color:red;text-align:cetner;'>Invalid URL </h3>"	


