from flask import session
from flask import request, Blueprint, jsonify
from sqlalchemy import create_engine, select, MetaData, Table,text
from sqlalchemy.sql import and_, or_

from core import app

engine = create_engine(app.config['DATABASE_URI'],pool_recycle=3600,future=True)
engine_fk = create_engine(app.config['DATABASE_URI_FK'],pool_recycle=3600,future=True)

class ConfModel():  
	def __init__(self):
		try:
			self.meta = MetaData()
	
			
		except Exception as e:
			print(e)

	def GetKITSessions(self,conf_id):
		with engine_fk.connect() as conn:
			stmt    = text("select * from kc_sessions where conf_id = "+str(conf_id)+" ;")
			result  = conn.execute(stmt).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results

	def GetFCSessions(self,conf_id):
		with engine_fk.connect() as conn:
			stmt    = text("select * from fc_sessions where conf_id = "+str(conf_id)+" ;")
			result  = conn.execute(stmt).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results
			
	def getConfDataByIdKey(self,conf_id,conf_key,current_dt = None):
		with engine.connect() as conn:
			stmt   = text("select * from conference where conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"' limit 1; ")
			result = conn.execute(stmt)
			result = result.one_or_none()
			return dict(result._mapping) if result else None
			