from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json


engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,pool_pre_ping=True,pool_recycle=3600)

class NotificationModel():  
	def __init__(self):
		try:
			self.meta = MetaData()
			self.app_notification    = Table("app_notification", self.meta, autoload=True, autoload_with=engine)
				
		except Exception as e:
			print(e)


	def get_notification_data(self):
		stmt = text("select * from app_notification where is_visible > 0  order by created_at desc ;")
		conn 	= engine.connect()
		result 	= conn.execute(stmt)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results :
			return results
		else:
			return None


	def insert_notification_data(self,data):
		conn = engine.connect()
		result = conn.execute(self.app_notification.insert(), data)
		conn.close()
		return result.lastrowid				