from flask import request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
from core.model.BadgeModel import BadgeModel
from core.model.RegdeskModel import RegdeskModel
from .. import  Custom


from .. import Cryptography
from flask import  app
from random import randint
import datetime
from datetime import timedelta,date,datetime,time
from werkzeug.utils import secure_filename
from os.path import join, dirname, realpath
import os
from collections import OrderedDict
from collections import defaultdict
from json import dumps

app = Blueprint('regdesk', __name__)



@app.route('/delegate_auto_present_generate', methods = ["GET", "POST"])
def DelegateAutoPresentGenerate():
	generate_present = RegdeskModel().generateDelegatePresent()
	return "success"

# http://127.0.0.1:5001/regdesk_login?api_key=w347H52d96&conf_key=selsi22&regdesk_pin=1234
#http://127.0.0.1:5003/regdesk_login?api_key=w347H52d96&regdesk_pin=2023
@app.route('/regdesk_login', methods = ["GET", "POST"])
def RegdeskLogin():
	json_data     = []
	confData      = []
	delegate_data = []
	msg           = ""
	signed_count  = 0
	now           = datetime.now()
	curr_dt       = now.strftime("%Y-%m-%d %H:%M:%S")
	curr_date     = now.strftime("%Y-%m-%d")
	try:
		APIKEY      = request.values.get("api_key",None)
		regdesk_pin = request.values.get('regdesk_pin') or None
		if APIKEY  and  APIKEY == Custom.APIKEY :
			confData    = RegdeskModel().getConfDataForRegdesk(regdesk_pin)
			if confData : 
				conf_start_time = confData["conf_start_time"]
				conf_end_time   = confData["conf_end_time"]
				del_table_name  = confData["del_table_name"]
				conf_id         = confData["conf_id"]
				conf_key        = confData["conf_key"]
				signup_table    = confData["signup_table"] # March 07 2023
				signup_for_alldays  = confData["signup_for_alldays"] # March 07 2023


				conf_start_time_str = conf_start_time.strftime("%Y-%m-%d %H:%M:%S")
				conf_end_time_str = conf_end_time.strftime("%Y-%m-%d %H:%M:%S")

				if conf_start_time < now < conf_end_time :
					delegateData = RegdeskModel().delegateData(conf_id,del_table_name,signup_for_alldays,signup_table,curr_date)
					if delegateData :
						delegate_data = delegateData
						key_order = ["delegate_id","delegate_no","role","full_name","email","mobile","city","state","membership_no","mc_number","counter","batch","signed_by","comments","signed_on","updated_at","conf_id"]
						
						 
						# for index,value in enumerate(delegate_data) : 
						# 	signed_on = value["signed_on"]
						# 	if signed_on :
						# 		signed_count = signed_count + 1
							
						data = {'conf_data' : confData ,'delegate_data' : delegate_data ,'signed_count': signed_count ,'msg' : "success", 'status' : 1}
						
						result = defaultdict(list)
						for dic in data["delegate_data"]:
							signed_on = dic["signed_on"]
							if signed_on :
								signed_count = signed_count + 1

							ordered = OrderedDict((key, dic.get(key)) for key in key_order)
							result["delegate_data"].append(ordered)

						data["signed_count"] = signed_count
						json_data = dumps(data ,default=str)
						return json_data

				elif conf_start_time > now :
					status   = 4
					msg      = "Conference not yet start. It will start on " + conf_start_time_str
					
				elif now > conf_end_time :
					status   = 5
					msg      = "Conference is completed on "+  conf_end_time_str
				else :
					status = "Try again"
					status = 6

				data = {'conf_data' : confData ,'delegate_data' : delegate_data ,'signed_count': signed_count ,'msg' : msg, 'status' : status}
			else :
				data = {'conf_data' : [] ,'delegate_data' : delegate_data ,'signed_count': signed_count,'msg' : 'Invalid pin or Regdesk may be closed.', 'status' : 3}
		else :
			data = {'conf_data' : [] ,'delegate_data' : delegate_data,'signed_count': signed_count, 'msg' : 'Invalid API KEY', 'status' : 2}

		json_data = json.dumps(data,default= str)
		return json_data			
	
	except Exception as e:
		data = {'conf_data' : [],'delegate_data' : delegate_data ,'signed_count': signed_count, 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data,default= str)
		return json_data
		
# http://127.0.0.1:5001/delegate_data_to_android?api_key=w347H52d96&conf_key=selsi22&regdesk_pin=1234
# @app.route('/delegate_data_to_android', methods = ["GET", "POST"])
# def DelegateDataToAndroid():
# 	json_data = {}
# 	now         = datetime.now()
# 	curr_dt     = now.strftime("%Y-%m-%d %H:%M:%S")
# 	try:
# 		APIKEY      = request.values.get("api_key",None)
# 		conf_key    = request.values.get('conf_key')  or None
# 		regdesk_pin = request.values.get('regdesk_pin') or None
# 		if APIKEY  and  APIKEY == Custom.APIKEY :
# 			confData    = RegdeskModel().getConfDataForRegdesk(conf_key)
# 			if confData : 
# 				db_regdesk_pin = confData["regdesk_pin"]
# 				if regdesk_pin and int(regdesk_pin) == db_regdesk_pin :
# 					conf_id         = confData["conf_id"]
# 					conf_start_time = confData["conf_start_time"]
# 					conf_end_time   = confData["conf_end_time"]
# 					del_table_name  = confData["del_table_name"]
# 					is_regdesk_open = confData["is_regdesk_open"]
# 					if is_regdesk_open  <= 0 :
# 						data = {'delegate_data' : [] , 'msg' : 'Regdesk not open', 'status' : 6}
# 					else :
# 						delegate_data   = RegdeskModel().delegateData(conf_id,del_table_name)
# 						if delegate_data :
# 							data = {'delegate_data' : delegate_data , 'msg' : 'success', 'status' : 1}
# 						else : 	
# 							data = {'delegate_data' : [] , 'msg' : 'Delegate record is empty', 'status' : 2}
# 				else :
# 					data = {'delegate_data' : [] , 'msg' : 'Invalid Pin', 'status' : 3}
# 			else :
# 				data = {'delegate_data' : [] , 'msg' : 'Invalid username', 'status' : 4}
# 		else :
# 			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}

# 		json_data = json.dumps(data,default= str)		
# 		return json_data			
	
# 	except Exception as e:
# 		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
# 		json_data = json.dumps(data,default= str)
# 		return json_data

# ---------------- not complete ------- Feb 25, 2023 
# http://127.0.0.1:5001/save_singup_record?api_key=w347H52d96&conf_id=1&delegate_no=1&del_table_name=delegates_iages23&signed_by=DELEGATE
@app.route('/save_signup_record', methods = ["GET", "POST"])
def SaveSignupRecord():
	json_data    = {}
	delegate_nos = []
	signed_count = 0
	msg          = ""
	update_stmt  = "" 
	signed_on_1    = None
	signed_count_1 = None
	is_valid     = "Invalid"
	now          = datetime.now()
	curr_dt      = now.strftime("%Y-%m-%d %H:%M:%S")
	curr_date     = now.strftime("%Y-%m-%d")
	try:
		conf_id	       = request.values.get('conf_id') or None
		APIKEY         = request.values.get("api_key") or None
		del_table_name = request.values.get('del_table_name') or None
		delegate_no    = request.values.get('delegate_no') or None

		signup_for_alldays = request.values.get('signup_for_alldays') or None
		signup_table       = request.values.get('signup_table') or None
			
		if delegate_no :
			delegate_no = int(delegate_no)

		signed_by	   = request.values.get('signed_by') or 'DELEGATE'	
		comments	   = request.values.get('comments') or None
		
		signed_on      = curr_dt
		sync_at        = curr_dt
		updated_at     = curr_dt

		if APIKEY  and  APIKEY == Custom.APIKEY :
			
			# param = str(conf_id)+ ","+str(delegate_no)+",'"+del_table_name+"','"+curr_dt+"','"+signed_by+"','"+comments+"',"+curr_date+"',"+str(signup_for_alldays)+",'"+signup_table+"'" 
			# print(str(conf_id)+ ","+str(delegate_no)+",'"+del_table_name+"','"+curr_dt+"','"+signed_by+"','"+comments+"',"+curr_date+"',"+str(signup_for_alldays)+",'"+signup_table+"'" )
			# return param
			update_and_get_count = RegdeskModel().updateAndGetSignedCount(conf_id,delegate_no,del_table_name,curr_dt,signed_by,comments,curr_date,signup_for_alldays,signup_table)
			if update_and_get_count :
				for index,value in enumerate(update_and_get_count) :
					if index == 0 :
						is_valid_1 = value
					if index == 1 :
						signed_on_1 = value
					if index == 2 :
						signed_count_1 = value	


				
				if signed_count_1 :
					signed_count = signed_count_1[0]["signed_count"]
				# March 01, 2023
				if is_valid_1 :
					is_valid  = is_valid_1[0]["is_valid"]
					signed_on = None
					if is_valid  != "Valid" :
						msg     = "Sorry !. " + str(delegate_no) + " is doesn't exists in badge count list"
						status  = 5
						data    = {"signed_count" : signed_count, "signed_on" : signed_on, "msg" : msg , "status" : status}
						json_data = json.dumps(data ,default=str)
						return json_data
				# end	

				if signed_on_1 :
					signed_on = signed_on_1[0]["signed_on"]
					if signed_on :
						status    = 3
						signed_on = datetime.strptime(signed_on, '%Y-%m-%d %H:%M:%S')
						signed_on = signed_on.strftime("%d-%m-%Y %H:%M:%S")
						msg       = "Already signed at " + signed_on
					else:
						status = 1
						msg    = "success"

				data = {"signed_count" : signed_count, "signed_on" : signed_on, "msg" : msg , "status" : status}
				json_data = json.dumps(data ,default=str)
				return json_data
			else :
				msg    = "Signed data does not exist"
				status = 4
				data   = {"signed_count" : signed_count, "signed_on" : "", "msg" : msg , "status" : status}
				json_data = json.dumps(data ,default=str)
				return json_data	
		else :
			data = {'signed_count' : 0 ,'signed_on' : "", 'msg' : 'Invalid API KEY', 'status' : 2}
			json_data = json.dumps(data ,default=str)
			return json_data	
	except Exception as e:
		data = {'signed_count' : 0,'signed_on' : "" , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data

# ---------------

# 2023-02-26 sync all data with signed count
# http://127.0.0.1:5003/sync_toandroid_with_count?api_key=w347H52d96&conf_id=1&del_table_name=delegates_iages23&signup_for_alldays=0&signup_table=numerote_primary_db_conf.signup_demo
@app.route('/sync_toandroid_with_count', methods = ["GET", "POST"])
def SyncToAndroidWithCount():
	json_data    = {}
	signed_count = 0
	msg          = ""
	now          = datetime.now()
	curr_dt      = now.strftime("%Y-%m-%d %H:%M:%S")
	curr_date    = now.strftime("%Y-%m-%d")
	key_order    = ["delegate_id","delegate_no","role","full_name","email","mobile","city","state","membership_no","mc_number","counter","batch","signed_by","comments","signed_on","updated_at","conf_id"]
	try:
		APIKEY         = request.values.get("api_key") or None
		conf_id	       = request.values.get('conf_id') or None
		del_table_name = request.values.get('del_table_name') or None
		date_1         = request.values.get('date_1') or curr_date # It means curr date
		# updated on March 07, 2023
		signup_for_alldays = request.values.get('signup_for_alldays') or 0
		signup_table       = request.values.get('signup_table') or None
		if APIKEY  and  APIKEY == Custom.APIKEY :
			delegate_data_and_count = RegdeskModel().syncAllDataWithSignedCount(conf_id,del_table_name,date_1,signup_for_alldays,signup_table)
			if delegate_data_and_count :
				for index,value in enumerate(delegate_data_and_count) :
					if index == 0 :
						delegate_data  = value

					if index == 1 :
						signed_count_1 = value	

				if signed_count_1 :
					signed_count = signed_count_1[0]["signed_count"]
					
				data = {"delegate_data" : delegate_data,"signed_count" : signed_count, "msg" : "success" , "status" : 1}

				result = defaultdict(list)
				for dic in data["delegate_data"]:
					ordered = OrderedDict((key, dic.get(key)) for key in key_order)
					result["delegate_data"].append(ordered)

				json_data = dumps(data ,default=str)
				return json_data
			else :
				msg    = "Signed data does not exist"
				status = 3
				data   = { "delegate_data" : "","signed_count" : signed_count,  "msg" : msg , "status" : status}
				
			# json_data = json.dumps(data ,default=str)
			json_data = jsonify(data)
			return json_data	
		else :
			data = {'delegate_data' : '','signed_count' : 0 ,'msg' : 'Invalid API KEY', 'status' : 2}
			json_data = json.dumps(data ,default=str)
			return json_data	
	except Exception as e:
		data = {'signed_count' : 0,'signed_count' : 0 , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data



# save  singed data and get only another device singed data to sent android 
# it reduce the loading time
# http://127.0.0.1:5001/save_singup_record?api_key=w347H52d96&del_table_name=delegates_selsi22&device_id=android123
# @app.route('/save_singup_record', methods = ["GET", "POST"])
# def SaveSignupRecord():
# 	json_data    = {}
# 	delegate_nos = []
# 	update_stmt  = "" 
# 	now          = datetime.now()
# 	curr_dt      = now.strftime("%Y-%m-%d %H:%M:%S")
# 	try:
# 		APIKEY         = request.values.get("api_key") or None
# 		del_table_name = request.values.get('del_table_name') or None
# 		delegate_no    = request.values.get('delegate_no') or None	
# 		signed_by	   = request.values.get('signed_by') or None	
# 		comments	   = request.values.get('comments') or None
# 		if APIKEY  and  APIKEY == Custom.APIKEY :
# 			sync_data = request.json
# 			if sync_data :
# 				for index,value in enumerate(sync_data) :
# 					delegate_no = value["delegate_no"]
# 					signed_on   = value["signed_on"]
# 					comments    = value["comments"]
# 					signed_by   = value["signed_by"]
# 					device_id   = value["device_id"]
# 					delegate_nos.append(delegate_no)
# 					update_stmt = update_stmt + " update  " + del_table_name + " set signed_on = '"+signed_on+"' , comments = '" + comments+"' , signed_by ='" + signed_by+"',sync_at= '"+curr_dt+"' , device_id = '"+device_id+"' where delegate_no = "+str(delegate_no)+ "; \n"

# 				delegate_no_str = str(delegate_nos)
# 				delegate_no_str = delegate_no_str.replace("[" , "").replace("]" , "")
				
# 				update_and_singed_data = RegdeskModel().updatRegdeskSignedData(del_table_name,update_stmt,delegate_no_str,device_id)
# 				if update_and_singed_data :
# 					data = {'delegate_data' : update_and_singed_data , 'msg' : 'success' ,'status' : 1}
# 				else : 
# 					data = {'delegate_data' : [] , 'msg' : 'No signed records to update' ,'status' : 2}

# 				json_data = json.dumps(data ,default=str)
# 				return json_data
# 			else :
# 				print("sync_data not exist")
# 				data = {'delegate_data' : [] , 'msg' : 'Signed in data not exist from API' ,'status' : 3}
# 				json_data = json.dumps(data ,default=str)
# 				return json_data	
# 		else :
# 			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}
# 			json_data = json.dumps(data ,default=str)
# 			return json_data	
# 	except Exception as e:
# 		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
# 		json_data = json.dumps(data ,default=str)
# 		return json_data

# http://127.0.0.1:5001/get_singup_record?api_key=w347H52d96&del_table_name=delegates_selsi22&device_id=android123
@app.route('/get_singup_record', methods = ["GET", "POST"])
def GetSignupRecord():
	json_data    = {}
	delegate_nos = []
	try:
		APIKEY         = request.values.get("api_key") or None
		del_table_name = request.values.get('del_table_name') or None
		device_id      = request.values.get('device_id') or None		
		if APIKEY  and  APIKEY == Custom.APIKEY :
			delegate_nos = request.json
			if delegate_nos :
				delegate_no_str = str(delegate_nos)
				delegate_no_str = delegate_no_str.replace("[" , "").replace("]" , "")
			else : 
				delegate_no_str  = None	
				
			get_singed_data = RegdeskModel().getRegdeskSignedData(del_table_name,delegate_no_str,device_id)
			if get_singed_data :
				data = {'delegate_data' : get_singed_data , 'msg' : 'success' ,'status' : 1}
			else : 
				data = {'delegate_data' : [] , 'msg' : 'No signed records to update' ,'status' : 2}	
				
		else :
			data = {'delegate_data' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}

		json_data = json.dumps(data,default =str)
		return json_data
	except Exception as e:
		data = {'delegate_data' : [] , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data	


# -------- March 03 2023 -----------------------------------
# Generate date list for show in dropdown list in android app
#http://192.168.1.10:5003/get_datelist?api_key=w347H52d96&conf_id=8
@app.route('/get_datelist', methods = ["GET", "POST"])
def GetDateList():
	json_data = {}
	date_list = []
	try:
		APIKEY         = request.values.get("api_key") or None
		conf_id        = request.values.get('conf_id') or None		
		if APIKEY  and  APIKEY == Custom.APIKEY :
			conf_data = RegdeskModel().getConfDates(conf_id)
			if conf_data :
				start_date = conf_data["conf_start_time"]
				end_date   = conf_data["conf_end_time"]
				curr_date  = start_date
				delta = end_date - start_date   # returns timedelta

				x = 2
				for i in range(delta.days + 1):
					x   = x+1
					day = start_date + timedelta(days=i)
					day_str = day.strftime("%d-%m-%Y")
					date_list.append(day_str)

				date_list.insert(0, "All Day")	
				
					
				data = {'date_list' : date_list , 'msg' : 'success' ,'status' : 1}
			else : 
				data = {'date_list' : [] , 'msg' : 'No dates' ,'status' : 2}	
				
		else :
			data = {'date_list' : [] , 'msg' : 'Invalid API KEY', 'status' : 5}

		json_data = json.dumps(data,default =str)
		return json_data
	except Exception as e:
		data = {'date_list' : [] , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data	

# http://192.168.1.10:5003/get_report?api_key=w347H52d96&conf_id=8&del_table_name=delegates_demo&date_1=2023-03-02
# @app.route('/get_report', methods = ["GET", "POST"])
# def GetReport():
# 	json_data = {}
# 	delegate_data = []
# 	signed_count  = 0 
# 	try:
# 		APIKEY         = request.values.get("api_key") or None
# 		conf_id        = request.values.get('conf_id') or None		
# 		del_table_name = request.values.get('del_table_name') or None
# 		date_1		   = request.values.get('date_1') or None
		

# 		if APIKEY  and  APIKEY == Custom.APIKEY :
# 			delegate_data = RegdeskModel().delegateDatByDatewise(conf_id,del_table_name,date_1)
# 			if delegate_data :
# 				signed_count = len(delegate_data)
# 				data = {'delegate_data' : delegate_data,'signed_count' :signed_count , 'msg' : 'success' ,'status' : 1}
# 			else : 
# 				data = {'delegate_data' : [],'signed_count' :signed_count , 'msg' : 'No dates' ,'status' : 2}	
				
# 		else :
# 			data = {'delegate_data' : [],'signed_count' :signed_count , 'msg' : 'Invalid API KEY', 'status' : 5}

# 		json_data = json.dumps(data,default =str)
# 		return json_data
# 	except Exception as e:
# 		data = {'delegate_data' : [],'signed_count' :signed_count , 'msg' : str(e), 'status' : 401}
# 		json_data = json.dumps(data ,default=str)
# 		return json_data


# March 08, 2023 Get overall count with role wise
# http://127.0.0.1:5003/get_overall_count?api_key=w347H52d96&conf_id=8&del_table_name=delegates_demo&signup_for_alldays=0&signup_table=numerote_primary_db_conf.signup_demo
@app.route('/get_overall_count', methods = ["GET", "POST"])
def GetOverallCount():
	json_data = {}
	delegate_data = []
	signed_count  = 0 
	oveall_signed_count = 0
	date_wise_count = None
	now           = datetime.now()
	curr_dt       = now.strftime("%Y-%m-%d %H:%M:%S")
	curr_date     = now.strftime("%Y-%m-%d")

	try:
		APIKEY         = request.values.get("api_key") or None
		conf_id        = request.values.get('conf_id') or None		
		del_table_name = request.values.get('del_table_name') or None
		date_1		       = request.values.get('date_1') or None
		signup_for_alldays = request.values.get('signup_for_alldays') or 0
		signup_table       = request.values.get('signup_table') or None
		

		if APIKEY  and  APIKEY == Custom.APIKEY :
			# CALL usp_android_get_overall_signed_count(8,'delegates_demo',null,1,'numerote_primary_db_conf.signup_demo');
			delegate_data = RegdeskModel().getOverAllcountRolewise(conf_id,del_table_name,date_1,signup_for_alldays,signup_table)
			if delegate_data :
				for index ,value in enumerate(delegate_data) : 
					if index == 0 :
						delegate_data = value
					if index == 1 :
						sign_count_result = value
					if index == 2 :
						date_wise_count = value	

					
				if sign_count_result :
					signed_count = 	sign_count_result[0]["oveall_signed_count"]
							

				data = {'delegate_data' : delegate_data,'signed_count' :signed_count ,'date_wise_count' : date_wise_count, 'msg' : 'success' ,'status' : 1}
			else : 
				data = {'delegate_data' : [],'signed_count' :signed_count,'date_wise_count' : date_wise_count , 'msg' : 'No dates' ,'status' : 2}	
				
		else :
			data = {'delegate_data' : [],'signed_count' :signed_count,'date_wise_count' : date_wise_count , 'msg' : 'Invalid API KEY', 'status' : 5}

		json_data = json.dumps(data,default =str)
		return json_data
	except Exception as e:
		data = {'delegate_data' : [],'signed_count' :signed_count,'date_wise_count' : date_wise_count , 'msg' : str(e), 'status' : 401}
		json_data = json.dumps(data ,default=str)
		return json_data		





	 
	

