from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.BadgeModel import BadgeModel
from core.model.QueryModel import QueryModel
from core.model.KitSessionModel import KitSessionModel


app = Blueprint('boquery', __name__)

# @app.route('/<int:conf_id>/<conf_key>', methods = ["GET", "POST"])
# def BOQueryLogin(conf_id,conf_key):
# 	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
# 	return render_template('query/backoffice_query/boquery_login.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data)

# @app.route('/<int:conf_id>/<conf_key>/bo_post_query_login', methods = ["GET", "POST"])
# def BOpostQueryLogin(conf_id,conf_key):
# 	if request.method == 'POST':
# 		username  = request.form['username']
# 		password  = request.form['password']
# 		get_conf  = BadgeModel().checkUsername(username,conf_id)
# 		if get_conf : 
# 			db_pass =  get_conf['badge_login_password']
# 			if password == db_pass:
# 				admin_id = get_conf['conf_id']
# 				session['boquerysession']   =  get_conf
# 				return redirect (url_for('boquery.BODays',conf_id=conf_id ,conf_key = conf_key))
# 			else:
# 				flash("Password is mismatch" , "errorMsg")
# 				return redirect (url_for('boquery.BOQueryLogin',conf_id=conf_id ,conf_key= conf_key))
# 		else:
# 			flash("Username is not registered." , "errorMsg")
# 			return redirect (url_for('boquery.BOQueryLogin',conf_id=conf_id ,conf_key= conf_key))
# 	else :
# 		return "Method not allowed"	



@app.route('/<int:conf_id>/<conf_key>/boquery', methods = ["GET", "POST"])
def BODays(conf_id,conf_key):
	now       = datetime.now()
	current_date   = now.strftime('%Y-%m-%d')
# 	conf_data = KitSessionModel().getkcConf(conf_id,conf_key,current_date)
	conf_data  = QueryModel().getConf_open_closedForQuery(conf_id,conf_key,current_date)
	if conf_data:
		getDays   = QueryModel().getDaysQueryModel(conf_data['abs_ses_table_name'],conf_id)
		return render_template('query/backoffice_query/bo_days.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,getDays=getDays,current_date=current_date)
	else:
		return "<h2 style= 'color:red;text-align:center' ; >Conference closed </h2>"
	


@app.route('/<int:conf_id>/<conf_key>/bo_halls/<conf_date>', methods = ["GET", "POST"])
def BOHalls(conf_id,conf_key,conf_date):
	conf_data = BadgeModel().GetConf(conf_id,conf_key)
	getHalls   = QueryModel().getHallsQueryModel(conf_data['abs_ses_table_name'],conf_id,conf_date)
	hall_1 = getHalls[0]
	return render_template('query/backoffice_query/bo_halls.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,getHalls=getHalls,conf_date=conf_date,hall_1=hall_1)
	

@app.route('/<int:conf_id>/<conf_key>/bo_session/<hall_id>/<conf_date>', methods = ["GET", "POST"])
def BOSession(conf_id,conf_key,hall_id,conf_date):
	conf_data = BadgeModel().GetConf(conf_id,conf_key)
	now              = datetime.now()
	current_dt   	 = now.strftime('%Y-%m-%d %H:%M:%S')
	data = QueryModel().usp_get_session_query_model(conf_id,hall_id,conf_date,current_dt)
	for index,value in enumerate(data):
		if index==0:
			getSessionName = value
		if index==1:
			if len(value)==0:
				currentsession = None
			else:
				currentsession=value[0]
		if index==2:
			count_query = value
	session_1 = getSessionName[0]
	return render_template('query/backoffice_query/bo_session.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,getSessionName=getSessionName,conf_date=conf_date,hall_id=hall_id,session_1=session_1,currentsession=currentsession,count_query=count_query)
	

@app.route('/<int:conf_id>/<conf_key>/bo_get_queries/<int:asession_id>/<int:query_id>/<int:hall_id>/<conf_date>', methods = ["GET", "POST"])
def BOgetQueries(conf_id,conf_key,asession_id,query_id,hall_id,conf_date):
	conf_data = BadgeModel().GetConf(conf_id,conf_key)
	sessionData   = QueryModel().get_sessionQueryModel(conf_data['abs_ses_table_name'],conf_id,asession_id)
	return render_template('query/backoffice_query/query_view.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,hall_id=hall_id,conf_date=conf_date,asession_id=asession_id,sessionData=sessionData)
	
	
@app.route('/<int:conf_id>/<conf_key>/bo_view_queries/<int:asession_id>', methods = ["GET", "POST"])
def BOviewQueries(conf_id,conf_key,asession_id):
	data = QueryModel().usp_get_pre_nxt_query_model(asession_id)
	for index,value in enumerate(data):
		if index==0:
			if len(value)==0:
				queries = None
			else:
				queries = value
	
	created_at_list = [];		
	if queries:
		for q in queries:
			created_at_list.append(q["created_at"])
		
	created_at_list.sort(reverse=True)	
	
	now              = datetime.now()
	current_dt   	 = now.strftime('%Y-%m-%d %H:%M:%S')
	
	last_sync_at = created_at_list[0].strftime('%Y-%m-%d %H:%M:%S') if len(created_at_list)>0 else current_dt
	html = render_template('query/backoffice_query/bo_query_view.html',conf_id=conf_id,conf_key=conf_key,queries=queries)
	return jsonify({'html':html,'last_sync_at':last_sync_at,'queries':queries})

		



@app.route('/<int:conf_id>/<conf_key>/get_auto_queries/<int:asession_id>', methods = ["GET", "POST"])
def BOgetAutoQueries(conf_id,conf_key,asession_id):
	conf_data = BadgeModel().GetConf(conf_id,conf_key)
	last_sync_at = request.form['last_sync_at'] or None
	queries = QueryModel().getAutoQueriesModel(conf_data['abs_ses_query_table_name'],asession_id,last_sync_at)
	
	created_at_list = [];		
	if queries:
		for q in queries:
			created_at_list.append(q["created_at"])
		
	created_at_list.sort(reverse=True)	
	
	now              = datetime.now()
	current_dt   	 = now.strftime('%Y-%m-%d %H:%M:%S')
	
	last_sync_at = created_at_list[0].strftime('%Y-%m-%d %H:%M:%S') if len(created_at_list)>0 else current_dt
	html = render_template('query/backoffice_query/bo_query_view_ajax.html',conf_id=conf_id,conf_key=conf_key,queries=queries)
	return jsonify({'html':html,'last_sync_at':last_sync_at})


@app.route('/<int:conf_id>/<conf_key>/bo_logout', methods = ["GET", "POST"])
def BOLogout(conf_id,conf_key):
	return redirect(url_for('boquery.BODays' ,conf_id = conf_id,conf_key= conf_key))


# <span style="float: right;"><i class="fa fa-arrow-right" aria-hidden="true"></i></span>

