from core import app
from flask import session
from core.model.UserModel import UserModel

class Auth:

	def check():
		if session.get('login',None):
			return True
		else:
			return False		

	def login(logindata):
		session['login'] = logindata 
		return session.get('login',None)

	def user():
		return session.get('login',None)

	def setConf(data):
		session['conf'] = data
		return session.get('conf',None)

	def getConf(conf_id,conf_key):
		if session.get('conf',None):
			return session.get('conf',None)
		else:
			conf = UserModel().get_conf(conf_id,conf_key)
			session['conf'] = conf
			return session.get('conf',None)
		

	def checkConf(conf_id,conf_key):
		conf = session.get('conf',None)
		if conf:
			if conf['conf_id'] == conf_id:
				return session.get('conf',None) # if conf session and match conf id then return data.
		#if conf is none or not match conf id then called bellow code 
		conf = UserModel().get_conf(conf_id,conf_key)
		session['conf'] = conf
		return session.get('conf',None)	
	

	def logout():
		session.pop('login', None)
		return True
	
	def bocheck():
		user = session.get('login',None)
		if user and user.get('is_admin') == 1:
			return True
		else:
			return False		

	def bologin(loginbodata):
		session['login'] = loginbodata 
		return session.get('bo_login',None)

	def bouser():
		return session.get('login',None)

	def bologout():
		session.pop('login', None)
		return True

	
app.jinja_env.globals.update(Auth=Auth)	
