CREATE DEFINER=`root`@`localhost` PROCEDURE `usp_save_kc_scanned_data`(in_session_id int ,in_delegate_no int ,kc_del_table_name varchar(80),kc_del_session_table_name varchar(80),kc_session_entry_table_name varchar(80) )
BEGIN
-- Created by Ganesan J on November 01 ,2022  12:33:00
-- call usp_save_kc_scanned_data(1, 105 ,'kc_delegates_selsi22','kc_delegates_sessions_selsi22','kc_sessions_entry_selsi22' );
set @in_session_id               = (select in_session_id);
set @in_delegate_no              = (select in_delegate_no);
set @kc_del_table_name           = (select kc_del_table_name);
set @kc_del_session_table_name   = (select kc_del_session_table_name);
set @kc_session_entry_table_name = (select kc_session_entry_table_name);
set @status_1  = 0;
-- set @curr_dt   = '2022-11-01 11:40:00';
set @curr_dt      = (select convert_tz(utc_timestamp() ,'+00:00','+05:30'));
set @role_1       = "";
set @full_name_1  = "";
set @is_scanned_1 = "";
 drop temporary table if exists response_kc_table;
 CREATE TEMPORARY TABLE response_kc_table(response_id INT PRIMARY KEY auto_increment,delegate_no int(11) default 0,
    full_name varchar(200) default null,role varchar(90) default null,scan_at  datetime default null,
    msg varchar(200) default null,status int(6) default 0); 
-- Step 1 : check delegate nubmer exists in delegate table
   set @check_delegate_number_exist =  ( concat('select full_name from ' , @kc_del_table_name, ' where delegate_no = ' , @in_delegate_no , ' INTO @full_name' )) ;
   prepare stmt_1 from  @check_delegate_number_exist ;
   execute  stmt_1;
   set @full_name_1 = (  select @full_name );
   -- select @full_name_1;
   if @full_name_1 is null  or CHAR_LENGTH(@full_name_1)  = 0 then 
     set @status_1 = 2;
     set @msg = ( select  concat ('#',@in_delegate_no,' <br/>  Not  Registered with us . ') as result);
  end if ; 
-- Step 2 : check delegate nubmer mapped with session id in delegates session  table 
    set @check_session_mapped  = (concat('select d.role from ' , @kc_del_table_name , ' d inner join '  , @kc_del_session_table_name , '  ds
    on ds.delegate_no = d.delegate_no where d.delegate_no = ' ,@in_delegate_no , ' and ds.session_id = ',@in_session_id,' limit 1  INTO @role_1' )  );
    -- select @check_session_mapped;
    prepare stmt_2 from  @check_session_mapped ;
    execute  stmt_2;
    -- select @role_1;
    if char_length(@role_1)= 0 and char_length(@full_name_1) > 0 then 
        set @status_1 = 4;
        set @msg = ( select "Service Denined" as result);
    end if ;   
-- Step 3 : check already scanned or not if not insert the record into the session entry table 
   set @is_scanned_sql  = (concat('SELECT created_at FROM ' , @kc_session_entry_table_name, ' where delegate_no = ' , @in_delegate_no , ' and session_id = ', @in_session_id, ' INTO @is_scanned_1 ;' ) )  ;
   prepare stmt_3 from @is_scanned_sql;
   execute stmt_3;
	if char_length(@full_name_1) > 0 and char_length(@role_1) > 0  and char_length(@is_scanned_1) = 0 then
		set @sql_1 = concat("insert into ", @kc_session_entry_table_name," (delegate_no,session_id,created_at) values(",@in_delegate_no,",",@in_session_id,",'",@curr_dt,"');");
		-- select @sql_1;
      prepare stmt from @sql_1 ;
		execute stmt ;
      set @status_1 = 1;
		set @msg = ( select  concat( '#', @in_delegate_no,' <br/> ', @full_name_1 , '<br/> Successfully Registered ') as result);
   end if;
-- Step 4 : check already scanned or not if already scanned don't insert the record
	if char_length(@full_name_1) > 0 and char_length(@is_scanned_1) > 0 then 
		set @msg = ( select  concat ('#', @in_delegate_no , '<br/> Already Registered with us .<br/> @ ' , @is_scanned_1) as result);
      set @status_1 = 3;
   end if;

   -- select char_length(@is_scanned_1);select char_length(@role_1) ; select char_length(@full_name_1);
   if char_length(@full_name_1) > 0 and char_length(@role_1) > 0  and char_length(@is_scanned_1) = 0 then
      insert into response_kc_table(delegate_no,full_name,role,scan_at ,msg ,status)values(@in_delegate_no,@full_name_1,@role_1,@curr_dt,@msg,@status_1);
   END IF;

   if char_length(@full_name_1) > 0 and char_length(@role_1) > 0  and char_length(@is_scanned_1) > 0 then
      insert into response_kc_table(delegate_no,full_name,role ,msg ,status)values(@in_delegate_no,@full_name_1,@role_1,@msg,@status_1);
   END IF;

   if char_length(@full_name_1) = 0 and char_length(@role_1) = 0  and char_length(@is_scanned_1) = 0 then
      insert into response_kc_table(delegate_no,full_name,role ,msg ,status)values(@in_delegate_no,null,null,@msg,@status_1);
  END IF;

   if char_length(@full_name_1) > 0 and char_length(@role_1) = 0  and char_length(@is_scanned_1) = 0 then
       insert into response_kc_table(delegate_no,full_name,role ,msg ,status)values(@in_delegate_no,@full_name_1,null,@msg,@status_1);
  END IF;
  
  select * from response_kc_table;
    set @full_name_1 = "";
    set @full_name = "";
END